; pic2.h
; header containing all the macros for the wwwpic project

;;========================================================================
;; Useful macros
;;========================================================================
TXLW macro ;k
  movlw       (\1)
  call        _tx
endm

SLITXLW macro ;k
  movlw       (\1)
  call        _slitx
endm

SUM0 MACRO ;x:req
__TMPSUM set (((\1)+((\1) >> 16)) >> 8)
    movlw (__TMPSUM & 0xff)
ENDM

SUM1 MACRO ;x:req
__TMPSUM set (((\1)+((\1) >> 16)) >> 0)
    movlw (__TMPSUM & 0xff)
ENDM

;;==========================================
;; macros originaly from the TASM source
;;==========================================

jump macro
    goto \1
endm

skip0 macro ;bit ;; skip if bit==0
btfsc     \1,\2
endm

skip1 macro ;bit ;; skip if bit==1
btfss     \1,\2
endm

brake  macro
local l1
  jump      l1
l1:
endm

jnz   macro ;k   ;; jump if Z==0
  skipz
  jump      \1
endm

jz    macro ;k   ;; jump if Z==1
  skipnz
  jump      \1
endm

jnc   macro ;k   ;; jump if C==0
  skipc
  jump      \1
endm

jc    macro ;k   ;; jump if C==1
  skipnc
  jump      \1
endm

.db macro ;
  if (\# >= 1)
    retlw \1
  endif
  if (\# >= 2)
    retlw \2
  endif
  if (\# >= 3)
    retlw \3
  endif
  if (\# >= 4)
    retlw \4
  endif
  if (\# >= 5)
    retlw \5
  endif
  if (\# >= 6)
    retlw \6
  endif
  if (\# >= 7)
    retlw \7
  endif
  if (\# >= 8)
    retlw \8
  endif
  if (\# >= 9)
    error
  endif

endm
